#!/usr/bin/perl
#
# Create a MIF file for the FG color ROM
#

@coltbl = ('KKKK', 'KWWW', 'KRGY', 'KRGB', 'KRGM', 'KRGC', 'KRGW', 'KRYB',
	   'KRYM', 'KRYC', 'KRYW', 'KRBM', 'KRBC', 'KRBW', 'KRMC', 'KRMW',
	   'KRCW', 'KGYB', 'KGYM', 'KGYC', 'KGYW', 'KGBM', 'KGBC', 'KGBW',
	   'KGMC', 'KGMW', 'KGCW', 'KYBM', 'KYBC', 'KYBW', 'KYMC', 'KYMW',
	   'KYCW', 'KBMC', 'KBMW', 'KBCW', 'KMCW', 'RGYB', 'RGYM', 'RGYC',
	   'RGYW', 'RGBM', 'RGBC', 'RGBW', 'RGMC', 'RGMW', 'RGCW', 'RYBM',
	   'RYBC', 'RYBW', 'RYMC', 'RYMW', 'RYCW', 'RBMC', 'RBMW', 'RBCW',
	   'RMCW', 'GYBM', 'GYBC', 'GYBW', 'GYMC', 'GYMW', 'GYCW', 'GBMC',
	   'GBMW', 'GBCW', 'GMCW', 'YBMC', 'YBMW', 'YBCW', 'YMCW', 'BMCW',
	   'KRKR', 'KKRR', 'KGKG', 'KKGG', 'KYKY', 'KKYY', 'KBKB', 'KKBB',
	   'KMKM', 'KKMM', 'KCKC', 'KKCC', 'KWKW', 'KKWW', 'RGRG', 'RRGG',
	   'RYRY', 'RRYY', 'RBRB', 'RRBB', 'RMRM', 'RRMM', 'RCRC', 'RRCC',
	   'RWRW', 'RRWW', 'GYGY', 'GGYY', 'GBGB', 'GGBB', 'GMGM', 'GGMM',
	   'GCGC', 'GGCC', 'GWGW', 'GGWW', 'YBYB', 'YYBB', 'YMYM', 'YYMM',
	   'YCYC', 'YYCC', 'YWYW', 'YYWW', 'BMBM', 'BBMM', 'BCBC', 'BBCC',
	   'BWBW', 'BBWW', 'MCMC', 'MMCC', 'MWMW', 'MMWW', 'CWCW', 'CCWW' );

# Note: bit 3 means opaque
%colenc = ('K' =>  0, 'B' =>  9, 'G' => 10, 'C' => 11,
	   'R' => 12, 'M' => 13, 'Y' => 14, 'W' => 15);

print "DEPTH = 512;\n";
print "WIDTH = 4;\n";
print "ADDRESS_RADIX = HEX;\n";
print "DATA_RADIX    = HEX;\n";
print "CONTENT\n";
print "BEGIN\n";

$a = 0;
for ($i = 0; $i < 128; $i++) {
    for ($x = 0; $x < 4; $x++) {
	$c = substr($coltbl[$i], $x, 1);
	$c = $colenc{$c};
	printf "%02X : %01X;\n", $a++, $c;
    }
}
print "END;\n";
